import matplotlib.pyplot as plt
import numpy as np


def LF(p, N, k):
    return (p ** k) * ((1.0 - p) ** (N - k))

n_grid = 100000

class PostP:
    def __init__(self, N, k):
        self.N = N
        self.k = k
        self.value = []
        sum = 0.0
        for i in range(0, n_grid + 1):
            v = LF(i / n_grid, self.N, self.k)
            self.value.append(v)
            sum += v

        for i in range(0, n_grid + 1):
            self.value[i] = self.value[i] / sum

    def d_p(self, i):
        return self.value[i]
        
while (True):
    N = int(input('N = '))
    if (N < 1):
        break
    k = int(input('k = '))

    postP = PostP(N, k)

    alpha = 0.05
 
    temp_L = 0
    temp_R = n_grid
    L_p = temp_L
    while True:
        if L_p == 0:
            SumP = postP.d_p(L_p)
            R_p = L_p
        else:
            SumP -= postP.d_p(L_p - 1)
        while (SumP < 1 - alpha):
            R_p += 1
            if R_p > n_grid:
                break
            SumP += postP.d_p(R_p)
            
        if R_p > n_grid:
            break
        if (temp_R - temp_L) > (R_p - L_p):
            temp_L = L_p
            temp_R = R_p

        L_p += 1
        if L_p > n_grid:
            break

    L_p = temp_L / n_grid
    R_p = temp_R / n_grid

    print('\nN = ', N, '  k = ', k)
    print('MAP = ', k / N)
    print('95% HDR = [{0:.3f}, {1:.3f}]'.format(L_p, R_p))

    plt.title(('MAP = {0:.3f}  for N = {1}, k = {2}\n'.format(k / N, N, k)) +
              ('95% HDR = [{0:.3f}, {1:.3f}]'.format(L_p, R_p)))

    x = []
    y = []
    for i in range(0, n_grid + 1, n_grid // 1000):
        x.append(i / n_grid)
        y.append(postP.d_p(i))

    plt.plot(x, y, 'b-')
    plt.show()
        

    
    



